package main

import (
	"encoding/base64"
	"fmt"
	"io"
	"log"
	"math/rand"
	"net/http"
	"time"
)

func main() {
	rnd := rand.New(rand.NewSource(time.Now().UnixNano()))

	pr, pw := io.Pipe()

	go func() {
		buf := make([]byte, 1024*1024)

		pw.Write([]byte(`{"email":"`))
		for {
			time.Sleep(time.Millisecond * 10)
			_, err := rnd.Read(buf)
			if err != nil {
				continue
			}

			_, err = pw.Write([]byte(base64.StdEncoding.EncodeToString(buf)))
			if err != nil {
				pw.CloseWithError(err)
				return
			}
		}
	}()

	req, err := http.NewRequest(http.MethodPost, "http://localhost:1337", nil)
	if err != nil {
		log.Fatal(err)
	}
	req.Body = pr

	hc := &http.Client{}

	res, err := hc.Do(req)
	if err != nil {
		log.Fatal(err)
	}

	fmt.Println(res.Status)
}
